 <template>
  <div>
    <div>
<CModal
           title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Storage Location Master</h5>
   
     <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border 
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectStorageLoc(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectStorageLoc(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectStorageLoc(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true">  New Storage Location</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title"> New Storage Location</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">


<!-- <div class="form-group"><label> Id</label>
<input type="text" name="workCent_Id" class="form-control form-control-sm" placeholder="shopFloorLocation Id" v-model="newStorageLoc.workCent_Id">
</div> -->

<div class="form-group"><label>Storage Loc Name</label>
<input type="text" name="storage_Loc_Name" class="form-control form-control-sm"  v-model="newStorageLoc.storage_Loc_Name">
</div>


<div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="newStorageLoc.workCent_Id">
     <option v-for="item in wcitems" :value="item.workCent_Id" :key="item.workCent_Id">{{ item.workCent_Name }} </option>
  </select>
</div>

<div class="form-group">
   <label for="workCent_Id">Type</label>
 <select class="form-control" v-model="newStorageLoc.type">
   <option value = "others" >Others</option> <option value = "SW" >SW</option>
  </select>
</div>

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addStorageLocs();" > Add Storage Location </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Storage Location Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group"><label>Storage Loc Id</label>
<input type="text" name="storage_Loc_Id" readonly class="form-control form-control-sm"  v-model="CurrentStorageLoc.storage_Loc_Id">
</div>

<div class="form-group"><label>Work Center</label>
<input type="text" name="workCent_Id" readonly class="form-control form-control-sm"  v-model="CurrentStorageLoc.workcentertype">
</div>

<div class="form-group"><label>Storage Loc Name</label>
<input type="text" name="storage_Loc_Name" readonly class="form-control form-control-sm"  v-model="CurrentStorageLoc.storage_Loc_Name">
</div>
<div class="form-group"><label>Storage Loc Type</label>
<input type="text" name="storage_Loc_Name" readonly class="form-control form-control-sm"  v-model="CurrentStorageLoc.type">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Storage Location</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<!-- <div class="form-group"><label>Storage Loc Id</label>
<input type="text" name="storage_Loc_Id" readonly class="form-control form-control-sm" placeholder="storage Loc Id" v-model="CurrentStorageLoc.storage_Loc_Id">
</div> -->


<div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="newStorageLoc.workCent_Id">
     <option v-for="item in wcitems" :value="item.workCent_Id" :key="item.workCent_Id">{{ item.workCent_Name }} </option>
  </select>
</div>
<div class="form-group">
   <label for="workCent_Id">Type</label>
 <select class="form-control" v-model="newStorageLoc.type">
   <option value = "Others" >others</option> <option value = "SW" >SW</option>
  </select>
</div>
<div class="form-group"><label>Storage Loc Name</label>
<input type="text" name="storage_Loc_Name" class="form-control form-control-sm"  v-model="newStorageLoc.storage_Loc_Name">
</div>
<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false;SelectStorageLoc(CurrentStorageLoc);UpdateStorageLocs();" > Update Storage Location </button>
</div>

</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Storage Location</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the Storage Location ? </h4>
<h5> You are deleting {{ this.CurrentStorageLoc.storage_Loc_Id +' || '+ this.CurrentStorageLoc.storage_Loc_Name }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem();getAllStorageLocDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const items = [
  { key: 'storage_Loc_Id', _style:'min-width:200px' },
  { key: 'workcentertype', _style:'min-width:100px;' },
  { key: 'storage_Loc_Name', _style:'min-width:50px;' }, 
    { key: 'type', _style:'min-width:50px;' }, 
 ]  
 const apigetworkcenter =  'Trace_WorkCenter_Master/'
 const apiget =  'Trace_Storage_Location_Master/'
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
             { key: 'storage_Loc_Id' , label: ' Id',},
             
              { key: 'storage_Loc_Name', label: 'Location Name', },   
               { key: 'workcentertype', label: 'Work Center', },
               { key: 'type', label: 'Type', }, 
               { key: 'show_details',  label: '',  _style: 'width:30%', },
             
                    
      ],
  
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentStorageLoc:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  wcitems:"",
  newStorageLoc: {storage_Loc_Id:0,workCent_Id:0,storage_Loc_Name:"",storage_Loc_Status:1,type:"",workcentertype:""}, }
  },


  
  mounted()
  {
   this.getAllStorageLocDetails();
   this.getAllWorkCenter();
  },

  methods:
  {
   getAllStorageLocDetails: function()
   {

   Vue.axios.get(this.$url+ apiget )
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.storage_Loc_Status == 1);
      console.log(response.data)
       // this.subitems = response.data.fgS_FIFO_StorageLoc_Type_Master;

       }
    });
   },

     getAllWorkCenter: function()
   {
 
   Vue.axios.get(this.$url + apigetworkcenter)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.wcitems =response.data.filter(x => x.status == 1);
     // console.log(response.data)
       }
    });
   },
   
  addStorageLocs()
  {
     if(this.items.find(x => x.storage_Loc_Name == this.newStorageLoc.storage_Loc_Name ))
    {
     this.SuccessMsg= "Location Name " + this.newStorageLoc.storage_Loc_Name +" already exist. Please try another Name";
    this.smallModal = true;
    }
    else if(this.newStorageLoc.storage_Loc_Name=="" ||this.newStorageLoc.workCent_Id == 0||this.newStorageLoc.type == null  )
    {
     this.SuccessMsg= "Please enter all fields";
    this.smallModal = true;
    }
    else
    {
    Vue.axios.post(this.$url+ apiget ,this.newStorageLoc).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        this.getAllStorageLocDetails();
        location.reload();
       }
    })
    }
   },

  UpdateStorageLocs()
  {
        
     if((this.CurrentStorageLoc.storage_Loc_Name != this.newStorageLoc.storage_Loc_Name ) && this.items.find(x => x.storage_Loc_Name == this.newStorageLoc.storage_Loc_Name && x.storage_Loc_Status == 1 ))
      {
        this.SuccessMsg= "Location Name " + this.newStorageLoc.storage_Loc_Name +" already exist. Please try another Name";
       this.smallModal = true;
       }
    else if(this.CurrentStorageLoc.storage_Loc_Name=="" || this.CurrentStorageLoc.workCent_Id == 0 || this.newStorageLoc.type == null  )
    {
      
     this.SuccessMsg= "Please enter all fields";
    this.smallModal = true;
    
    }
    else {
          
        this.newStorageLoc.storage_Loc_Id = this.CurrentStorageLoc.storage_Loc_Id;
        
       Vue.axios.put(this.$url+ apiget +this.newStorageLoc.storage_Loc_Id,this.newStorageLoc).then((response)=>{
        if(response.data.error)
        {
           alert('Data Error')
           }
   
         else
        {
          this.SuccessMsg ="Records Updated Successfully.."
         this.getAllStorageLocDetails();
          location.reload();
        }
    })
    }
   },

  deleteItem()
    {
      var storage_Loc_Id = this.CurrentStorageLoc.storage_Loc_Id;
        axios({   method: 'delete',
           url: this.$url+ apiget + storage_Loc_Id
    });
        this.SuccessMsg="Storage Location Status Changed to Inactive Succesfully"
        this.getAllStorageLocDetails();
          location.reload();
    },
      
  SelectStorageLoc(StorageLoc)
    {
     this.CurrentStorageLoc=StorageLoc;
     //alert(this.CurrentStorageLoc.storage_Loc_Id);
    },

  } 
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>